AsyncBoxView.ChildLocator (Java Platform SE 8 )
Keywords: javax.swing.text.AsyncBoxView.ChildLocator class
Date: 2020-03-26

javax.swing.text

## Class AsyncBoxView.ChildLocator

- java.lang.Object
- - javax.swing.text.AsyncBoxView.ChildLocator

- Enclosing class:
    AsyncBoxView

      public class AsyncBoxView.ChildLocator
      extends Object

  A class to manage the effective position of the child views in a localized area while changes are being made around the localized area. The AsyncBoxView may be continuously changing, but the visible area needs to remain fairly stable until the layout thread decides to publish an update to the parent.
  Since:
    1.3

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Rectangle` | `childAlloc` A shape to use for the child allocation to avoid creating a lot of garbage.
    `protected Rectangle` | `lastAlloc` The last seen allocation (for repainting when changes are flushed upward).
    `protected AsyncBoxView.ChildState` | `lastValidOffset` The location of the last offset calculation that is valid.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ChildLocator()` construct a child locator.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `childChanged(AsyncBoxView.ChildState cs)` Notification that a child changed.
    `protected Shape` | `getChildAllocation(int index)` Fetch the allocation to use for a child view.
    `Shape` | `getChildAllocation(int index, Shape a)` Fetch the allocation to use for a child view.
    `int` | `getViewIndexAtPoint(float x, float y, Shape a)` Fetches the child view index at the given point.
    `protected int` | `getViewIndexAtVisualOffset(float targetOffset)` Locate the view responsible for an offset into the box along the major axis.
    `void` | `paintChildren(Graphics g)` Paint the children that intersect the clip area.
    `protected void` | `setAllocation(Shape a)` Copy the currently allocated shape into the Rectangle used to store the current allocation.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### lastValidOffset

          protected AsyncBoxView.ChildState lastValidOffset

      The location of the last offset calculation that is valid.

    - #### lastAlloc

          protected Rectangle lastAlloc

      The last seen allocation (for repainting when changes are flushed upward).

    - #### childAlloc

          protected Rectangle childAlloc

      A shape to use for the child allocation to avoid creating a lot of garbage.

  - ### Constructor Detail

    - #### ChildLocator

          public ChildLocator()

      construct a child locator.

  - ### Method Detail

    - #### childChanged

          public void childChanged(AsyncBoxView.ChildState cs)

      Notification that a child changed. This can effect whether or not new offset calculations are needed. This is called by a ChildState object that has changed it's major span. This can therefore be called by multiple threads.

    - #### paintChildren

          public void paintChildren(Graphics g)

      Paint the children that intersect the clip area.

    - #### getChildAllocation

          public Shape getChildAllocation(int index,
                                          Shape a)

      Fetch the allocation to use for a child view. This will update the offsets for all children not yet updated before the given index.

    - #### getViewIndexAtPoint

          public int getViewIndexAtPoint(float x,
                                         float y,
                                         Shape a)

      Fetches the child view index at the given point. This is called by the various View methods that need to calculate which child to forward a message to. This should be called by a block synchronized on this object, and would typically be followed with one or more calls to getChildAllocation that should also be in the synchronized block.
      Parameters:
        `x` - the X coordinate >= 0
        `y` - the Y coordinate >= 0
        `a` - the allocation to the View
      Returns:
        the nearest child index

    - #### getChildAllocation

          protected Shape getChildAllocation(int index)

      Fetch the allocation to use for a child view. This does not update the offsets in the ChildState records.

    - #### setAllocation

          protected void setAllocation(Shape a)

      Copy the currently allocated shape into the Rectangle used to store the current allocation. This would be a floating point rectangle in a Java2D-specific implementation.

    - #### getViewIndexAtVisualOffset

          protected int getViewIndexAtVisualOffset(float targetOffset)

      Locate the view responsible for an offset into the box along the major axis. Make sure that offsets are set on the ChildState objects up to the given target span past the desired offset.
      Returns:
        index of the view representing the given visual location (targetOffset), or -1 if no view represents that location

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2020, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.